const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const venues = sequelize.define(
    'venues',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

address: {
        type: DataTypes.TEXT,
      
      

      },

map_url: {
        type: DataTypes.TEXT,
      
      

      },

default_field_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  venues.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity














    db.venues.hasMany(db.games, {
      as: 'games_venue',
      foreignKey: {
          name: 'venueId',
      },
      constraints: false,
    });















//end loop



    db.venues.belongsTo(db.clubs, {
      as: 'club',
      foreignKey: {
        name: 'clubId',
      },
      constraints: false,
    });

    db.venues.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.venues.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.venues.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return venues;
};


